/*
 * foxybot.h
 *	Foxy's Multipurpose Bot for Eulora.
 *
 *	The bot can be accessed (basically started or stopped) via the /bot command (added to cmdusers.cpp). The bot has its own window in which it will give feedback on its activity and/or any errors that it may encounter.
 *
 *	Usage:
 *	- to start an activity: /bot explore|craft parameters
 *	- to stop an activity: /bot stop|reset
 *
 *  Created on: 22 Jul 2015
 *      Author: Diana Coman
 */
#ifndef CRAFT_BOT_HEADER
#define CRAFT_BOT_HEADER

#include "paws/pawswidget.h"
#include "botlog.h"
#include "botactivity.h"
#include "util/strutil.h"

/** A bot for crafting items and exploring/building claims in Eulora
 */
class foxyBot : public pawsWidget, public psClientNetSubscriber
{
public:
    foxyBot();
    virtual ~foxyBot();

    bool PostSetup();

    csString ExecuteCmd(csString cmd);
    void HandleMessage( MsgEntry* message );

private:
    pawsMessageTextBox* textbox;
    BotLogCSV* logger;
    static const int activitiesCount = 3;
    BotActivity* activities[activitiesCount];
    int textcolour;

    //own utilities
    void OutputMsg(csString msg);

};

CREATE_PAWS_FACTORY( foxyBot );

#endif
